#include "Audio.h"

Audio::Audio()
{
	initSound();
}

Audio::~Audio()
{
	Performance->CloseDown();
	Performance->Release();
	Loader->Release();
	CoUninitialize();
}

void Audio::initSound( void )
{
	// get the window handle
	hwnd = FindWindow("GLUT","Track DEMO");
	// Initialize COM...
	CoInitialize( NULL );

	// Declare a performance object
	CoCreateInstance(CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC, 
		IID_IDirectMusicPerformance8, (void**) &Performance);

	Performance->InitAudio( NULL,
							NULL,
							hwnd,
							DMUS_APATH_SHARED_STEREOPLUSREVERB,
							64,
							DMUS_AUDIOF_ALL,
							NULL);
	//Performance = IDirectMusicPerformance*[4];

	// create and initialize the loader
	CoCreateInstance(CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC, 
		IID_IDirectMusicLoader8, (void**) &Loader);

	char searchPath[MAX_PATH];
	WCHAR wSearchPath[MAX_PATH];

	GetCurrentDirectory(MAX_PATH, searchPath);
	MultiByteToWideChar(CP_ACP, 0, searchPath, -1, wSearchPath, MAX_PATH);

    Loader->SetSearchDirectory(GUID_DirectMusicAllTypes, wSearchPath, FALSE);
}

Sound::Sound()
{

}

Sound::Sound(char* file)
{

	// initialize the segment
	segment = NULL;
	CoCreateInstance(CLSID_DirectMusicSegment, NULL, CLSCTX_INPROC,
		IID_IDirectMusicSegment8, (void**) &segment);

	// load the segment
	filename = file;
	WCHAR wFilename[MAX_PATH];

	MultiByteToWideChar(CP_ACP, 0, filename, -1, wFilename, MAX_PATH);

	Loader->LoadObjectFromFile(CLSID_DirectMusicSegment,
		 IID_IDirectMusicSegment8,
		wFilename,
		(void**) &segment);

	// download the music band
	segment->Download(Performance);
}
Sound::~Sound()
{
	segment->Release();
}
void Sound::playBG()
{
	Performance->PlaySegmentEx(segment, NULL, NULL, 0, 0, NULL, NULL, NULL);
}
void Sound::playSFX()
{
	Performance->PlaySegmentEx(segment, NULL, NULL, DMUS_SEGF_SECONDARY, 0, NULL, NULL, NULL);
}
void Sound::stop()
{
	Performance->StopEx(segment, 0, 0);
}
void Sound::stopAll()
{
	Performance->Stop(NULL, NULL, 0, 0);
}

