#ifndef _HEIGHTMAP_
#define _HEIGHTMAP_

#include "Object.h"

#define TERRAIN_ERROR_LOADING_IMAGE 50// - this value is returned when there is a problem loading the image.
#define TERRAIN_ERROR_MEMORY_PROBLEM 51//- Oops, no memory to hold the terrain data
#define TERRAIN_ERROR_NOT_SAVED 52//- There was a problem saving the file
#define TERRAIN_ERROR_NOT_INITIALISED 53//- occurs when a function to act upon the terrain is called but there is no terrain!
#define TERRAIN_OK 54//- This what we want, no errors!

class HeightMap {
public:
	int callstackNumber;
	int terrainGridWidth;
	int terrainGridLength; //- the number of heights available on the y axis.
	float* terrainHeights;// - A one-dimensional array containing the heights
	float* terrainColors;// - A one-dimensional array containing the RGB colors for each height
	float* terrainNormals;// - A one-dimensional array containing the normals for each height
//public:
	HeightMap();
	~HeightMap();
	void loadMap();
	int terrainLoadFromImage(char *filename, int normals);
	void HeightMapClear();
	int getCallStackNumber();
	int terrainScale(float min,float max);
	float terrainGetHeight(int x, int z); 
	float* terrainCrossProduct(int x1,int z1,int x2,int z2,int x3,int z3);
	void terrainNormalize(float *v);
    void terrainAddVector(float *a, float *b);
    void terrainComputeNormals();
};

#endif