#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>
#include "Mobile.h"

Mobile::Mobile() : Object () {
	currentVectorIndex = 0;
	vectorSet = false;
	movable = true;
	moveSpeed = 0;
	missile = false;
	target = NULL;
	owner = 1;
}

Mobile::~Mobile() {

}

void 
Mobile::addToPath(float x, float y, float z) {
	triple temp;
	temp.x = x;
	temp.y = y;
	temp.z = z;
	vectorList.push_back(temp);
}

void 
Mobile::nextVector() {
	vectorSet = false;
	if (currentVectorIndex <= (vectorList.size() -1) ) {
		currentVectorIndex++;
	}
	else {
		currentVectorIndex = 0;
	}
}

triple 
Mobile::getCurrentVector() {
	triple vector;
	// do vector subtraction and normalization
	if ( !vectorSet ) {
		triple fromPoint;	
		triple toPoint;
		if (missile) {
			fromPoint = coordinates;
			toPoint = target->getCoordinates();
		}
		else if (currentVectorIndex == 0) {
			fromPoint = coordinates;
			toPoint = vectorList[0];
		}
		else if (currentVectorIndex <= (vectorList.size() - 1) ) {
			fromPoint = vectorList[currentVectorIndex-1];
			toPoint = vectorList[currentVectorIndex];
		}
		else {
			currentVectorIndex = 0;	
			fromPoint = coordinates;
			toPoint = vectorList[0];
		}	
		// get the vector
		vector.x = toPoint.x - fromPoint.x;
		vector.y = toPoint.y - fromPoint.y;
		vector.z = toPoint.z - fromPoint.z;
		// normalize
		float length = sqrt((vector.x*vector.x) + (vector.y*vector.y) + (vector.z*vector.z));
		vector.x = vector.x / length;
		vector.y = vector.y / length;
		vector.z = vector.z / length;
		
		if (!missile) {
			vectorSet = true;
		}

		currentVector = vector;
	}
	else {
		vector = currentVector;
	}

	return vector;
}

bool 
Mobile::atTurnpoint(triple position) {
	if ( !missile &&
		 (abs(vectorList[currentVectorIndex].x - position.x) < moveSpeed*2) &&
		 (abs(vectorList[currentVectorIndex].z - position.z) < moveSpeed*2) &&
		 (abs(vectorList[currentVectorIndex].y - position.y) < moveSpeed*2)	
		)  {
		return true;
	}
	else {
		return false;
	}
}

void 
Mobile::moveCoordinatesToVector() {

	if ( (!missile) && atTurnpoint(coordinates)) {
		nextVector();
	}
	
	triple travelVector = getCurrentVector();
	coordinates.x += travelVector.x*moveSpeed;
	coordinates.y += travelVector.y*moveSpeed;
	coordinates.z += travelVector.z*moveSpeed;
}

bool 
Mobile::checkHit(int& kill) {
	kill = 0;
	if (!missile) {
		return false;
	}
	float x, y, z;
	x = coordinates.x;
	y = coordinates.y;
	z = coordinates.z;
	if (target->hitByCoords(x,y,z) ) {
		target->hitpoints -= yield;
		if ( (target->hitpoints <= 0) && (target->drawable) ) {
			target->kill();
			kill = target->worth;
		}
		this->kill();
		return true;
	}
	else {
		return false;
	}
}
