#ifndef _OBJECTNODE_
#define _OBJECTNODE_

#include <stdio.h>
#include <glut.h>

class  Node {
public:
	GLfloat localMatrix[16];
	GLfloat animateMatrix[16];
	Node* sibling;
	Node* child;
	GLfloat keyRotate[3];
	int callstackid;

	Node();
	void loadMesh(char* fname);
};

class ObjectHierarchy {

private:
	Node* head;
	void destroy(Node* n);
	void animateDelta(Node* root, float inc);
	void traverse(Node* root);

public:
	ObjectHierarchy();
	~ObjectHierarchy();
	void addHead(Node* n);
	void animateDelta_object(float inc);
	void traverse_object();

};

#endif
