#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glut.h>

#define TGA_ERROR_FILE_OPEN 100
#define TGA_ERROR_READING_FILE 101
#define TGA_ERROR_INDEXED_COLOR 102
#define TGA_ERROR_MEMORY 103
#define TGA_ERROR_COMPRESSED_FILE 104
#define TGA_OK 105

typedef struct {
	int status;
	unsigned char type, pixelDepth;
	short int width, height;
	unsigned char *imageData;
}tgaInfo;

int tgaSaveSeries(char		*filename, 
			 short int		width, 
			 short int		height, 
			 unsigned char	pixelDepth,
			 unsigned char	*imageData);

// load the image header fields. We only keep those that matter!
void tgaLoadHeader(FILE *file, tgaInfo *info);

// loads the image pixels. You shouldn't call this function
// directly
void tgaLoadImageData(FILE *file, tgaInfo *info);	

// this is the function to call when we want to load
// an image
tgaInfo * tgaLoad(char *filename);	

// converts RGB to greyscale
void tgaRGBtogreyscale(tgaInfo *info);

// takes a screen shot and saves it to a TGA image
int tgaGrabScreenSeries(char *filename, int xmin,int ymin, int xmax, int ymax);




// saves an array of pixels as a TGA image
int tgaSave(	char 		*filename, 
		short int	width, 
		short int	height, 
		unsigned char	pixelDepth,
		unsigned char	*imageData);


// releases the memory used for the image
void tgaDestroy(tgaInfo *info);
